@use "../sable";

.bg-fixed {
  @include sable.bg-background-attachment(fixed);
}
.bg-local {
  @include sable.bg-background-attachment(local);
}
.bg-scroll {
  @include sable.bg-background-attachment(scroll);
}

.bg-clip-border {
  @include sable.bg-background-clip(border-box);
}
.bg-clip-padding {
  @include sable.bg-background-clip(padding-box);
}
.bg-clip-content {
  @include sable.bg-background-clip(content-box);
}
.bg-clip-text {
  @include sable.bg-background-clip(text);
}

.bg-origin-border {
  @include sable.bg-background-origin(border-box);
}
.bg-origin-padding {
  @include sable.bg-background-origin(padding-box);
}
.bg-origin-content {
  @include sable.bg-background-origin(content-box);
}

.bg-bottom {
  @include sable.bg-background-position(bottom);
}
.bg-center {
  @include sable.bg-background-position(center);
}
.bg-left {
  @include sable.bg-background-position(left);
}
.bg-left-bottom {
  @include sable.bg-background-position(left bottom);
}
.bg-left-top {
  @include sable.bg-background-position(left top);
}
.bg-right {
  @include sable.bg-background-position(right);
}
.bg-right-bottom {
  @include sable.bg-background-position(right bottom);
}
.bg-right-top {
  @include sable.bg-background-position(right top);
}
.bg-top {
  @include sable.bg-background-position(top);
}

.bg-repeat {
  @include sable.bg-background-repeat(repeat);
}
.bg-no-repeat {
  @include sable.bg-background-repeat(no-repeat);
}
.bg-repeat-x {
  @include sable.bg-background-repeat(repeat-x);
}
.bg-repeat-y {
  @include sable.bg-background-repeat(repeat-y);
}

.bg-auto {
  @include sable.bg-background-size(auto);
}
.bg-cover {
  @include sable.bg-background-size(cover);
}
.bg-contain {
  @include sable.bg-background-size(contain);
}

.bg-none {
  @include sable.bg-background-image(none);
}

@each $bpName, $width in sable.$fun-breakpoints {
  @media (min-width: #{$width}) {
    .#{$bpName}\:bg-fixed {
      @include sable.bg-background-attachment(fixed);
    }
    .#{$bpName}\:bg-local {
      @include sable.bg-background-attachment(local);
    }
    .#{$bpName}\:bg-scroll {
      @include sable.bg-background-attachment(scroll);
    }
    
    .#{$bpName}\:bg-clip-border {
      @include sable.bg-background-clip(border-box);
    }
    .#{$bpName}\:bg-clip-padding {
      @include sable.bg-background-clip(padding-box);
    }
    .#{$bpName}\:bg-clip-content {
      @include sable.bg-background-clip(content-box);
    }
    .#{$bpName}\:bg-clip-text {
      @include sable.bg-background-clip(text);
    }
    
    .#{$bpName}\:bg-origin-border {
      @include sable.bg-background-origin(border-box);
    }
    .#{$bpName}\:bg-origin-padding {
      @include sable.bg-background-origin(padding-box);
    }
    .#{$bpName}\:bg-origin-content {
      @include sable.bg-background-origin(content-box);
    }
    
    .#{$bpName}\:bg-bottom {
      @include sable.bg-background-position(bottom);
    }
    .#{$bpName}\:bg-center {
      @include sable.bg-background-position(center);
    }
    .#{$bpName}\:bg-left {
      @include sable.bg-background-position(left);
    }
    .#{$bpName}\:bg-left-bottom {
      @include sable.bg-background-position(left bottom);
    }
    .#{$bpName}\:bg-left-top {
      @include sable.bg-background-position(left top);
    }
    .#{$bpName}\:bg-right {
      @include sable.bg-background-position(right);
    }
    .#{$bpName}\:bg-right-bottom {
      @include sable.bg-background-position(right bottom);
    }
    .#{$bpName}\:bg-right-top {
      @include sable.bg-background-position(right top);
    }
    .#{$bpName}\:bg-top {
      @include sable.bg-background-position(top);
    }
    
    .#{$bpName}\:bg-repeat {
      @include sable.bg-background-repeat(repeat);
    }
    .#{$bpName}\:bg-no-repeat {
      @include sable.bg-background-repeat(no-repeat);
    }
    .#{$bpName}\:bg-repeat-x {
      @include sable.bg-background-repeat(repeat-x);
    }
    .#{$bpName}\:bg-repeat-y {
      @include sable.bg-background-repeat(repeat-y);
    }
    
    .#{$bpName}\:bg-auto {
      @include sable.bg-background-size(auto);
    }
    .#{$bpName}\:bg-cover {
      @include sable.bg-background-size(cover);
    }
    .#{$bpName}\:bg-contain {
      @include sable.bg-background-size(contain);
    }
    
    .#{$bpName}\:bg-none {
      @include sable.bg-background-image(none);
    }
  }
}
